#!/bin/bash

# This helper script will handle generation of the redis config from secrets
#
# /scripts/gen-redis-config.sh
#

set -e


source /scripts/utils.sh

config=${configDir}/redis.conf

# Note: this config format is for recent redis versions (wont work with the very old
# artifactory-pub.bit9.local:5000/cbd/redis:latest is version 4.0.9

# TODO any other settings for dev usage?
echo "bind 0.0.0.0" > ${config}
#TODO: NOTE: the statement below is needed only for versions <6.0, add an if condition to exclude this statement from config for versions 6.0 and above
echo "requirepass ${primaryPassword}" >> ${config}

#TODO: add an if condition to include the configurations below for redis version 6.x as redis supports ssl and acl only from version 6.0
#please refer https://redis.io/topics/encryption for more information on this
#---- configurations to be used for 6.0-----#
# echo -n "user default on +@all ~* >" >> ${config}
# echo ${primaryPassword} >> ${config}
# echo "" >> ${config}

# # Wire up TLS configuration
# echo "port 0" >> ${config}
# echo "tls-port 6379" >> ${config}
# echo "tls-cert-file /etc/redis-tls/cert.pem" >> ${config}
# echo "tls-key-file /etc/redis-tls/key.pem" >> ${config}
# echo "tls-ca-cert-file /etc/redis-tls/cert.pem" >> ${config}
# echo "tls-auth-clients no" >> ${config}
#---- configurations to be used for 6.0-----#

# Note: this isn't wired up since it doesn't appear possible to deploy
# elasticache with a username+password, just a password, so keeping dev/prod in sync
# echo -n "user " >> ${config}
# cat ${secretDir}/username  >> ${config}
# echo -n " on +@all ~* >" >> ${config}
# cat ${secretDir}/password >> ${config}
# echo "" >> ${config}

cprint "$0 done"
